/*---------------------------------------- Listing 3 ------
 * Demonstration of the SIGFPE signal.
 * See Listing 1 for copyright terms.
 *-------------------------------------------------------*/
#include <stdio.h>
#include <signal.h>

void FpeHandler ( int Signal, int SubCode );
void main ( void );

void FpeHandler ( int Signal, int SubCode )
{
    printf( "Signal %d, SubCode %d was raised\n", 
             Signal, SubCode );
}

void main ( void )
{
    void (*OldHandler) ( int Signal );

    OldHandler = signal ( SIGFPE, FpeHandler );
    if ( OldHandler == SIG_ERR )
        printf ( "signal failed\n" );

    raise ( SIGFPE );
}